diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-spectrum-value-helper.cc ns-3.43/src/wifi/model/wifi-spectrum-value-helper.cc
--- ns-3.42/src/wifi/model/wifi-spectrum-value-helper.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-spectrum-value-helper.cc	2024-10-09 16:41:10.132656800 -0700
@@ -208,181 +242,269 @@
     };
     WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands);
     CreateSpectrumMaskForOfdm(c,
-                              subBands,
+                              {subBands},
                               maskBand,
-                              txPowerPerBandW,
+                              txPowerPerBand,
                               nGuardBands,
                               innerSlopeWidth,
-                              minInnerBandDbr,
-                              minOuterBandDbr,
-                              lowestPointDbr);
-    NormalizeSpectrumMask(c, txPowerW);
-    NS_ASSERT_MSG(std::abs(txPowerW - Integral(*c)) < 1e-6, "Power allocation failed");
+                              minInnerBand,
+                              minOuterBand,
+                              lowestPoint);
+    NormalizeSpectrumMask(c, txPower);
+    NS_ASSERT_MSG(std::abs(txPower - Integral(*c)) < 1e-6, "Power allocation failed");
     return c;
 }
 
 Ptr<SpectrumValue>
 WifiSpectrumValueHelper::CreateDuplicated20MhzTxPowerSpectralDensity(
-    uint32_t centerFrequency,
-    uint16_t channelWidth,
-    double txPowerW,
-    uint16_t guardBandwidth,
-    double minInnerBandDbr,
-    double minOuterBandDbr,
-    double lowestPointDbr,
+    const std::vector<MHz_u>& centerFrequencies,
+    MHz_u channelWidth,
+    Watt_u txPower,
+    MHz_u guardBandwidth,
+    dBr_u minInnerBand,
+    dBr_u minOuterBand,
+    dBr_u lowestPoint,
     const std::vector<bool>& puncturedSubchannels)
 {
-    NS_LOG_FUNCTION(centerFrequency << channelWidth << txPowerW << guardBandwidth << minInnerBandDbr
-                                    << minOuterBandDbr << lowestPointDbr);
-    uint32_t carrierSpacing = 312500;
+    NS_ASSERT_MSG(centerFrequencies.size() == 1 ||
+                      (channelWidth == 160 && centerFrequencies.size() <= 2),
+                  "PSD for non-contiguous channels is only possible when the total width is 160 "
+                  "MHz and cannot be made of more than 2 segments");
+    NS_LOG_FUNCTION(printFrequencies(centerFrequencies)
+                    << channelWidth << txPower << guardBandwidth << minInnerBand << minOuterBand
+                    << lowestPoint);
+    const Hz_u carrierSpacing = 312500;
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
-        GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth));
-    auto nGuardBands = static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
-    auto nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
-    NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() == (nAllocatedBands + nGuardBands + 1),
+        GetSpectrumModel(centerFrequencies, channelWidth, carrierSpacing, guardBandwidth));
+    // assume all frequency segments have the same width, hence split the guard bandwidth
+    // accordingly over the segments
+    guardBandwidth /= centerFrequencies.size();
+    const auto nGuardBands =
+        static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
+    const auto nAllocatedBands =
+        static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+    const auto separationWidth = std::abs(centerFrequencies.back() - centerFrequencies.front());
+    const auto unallocatedWidth = separationWidth > 0 ? (separationWidth - (channelWidth / 2)) : 0;
+    const auto nUnallocatedBands =
+        static_cast<uint32_t>(((unallocatedWidth * 1e6) / carrierSpacing) + 0.5);
+    NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() ==
+                      (nAllocatedBands + nGuardBands + nUnallocatedBands + 1),
                   "Unexpected number of bands " << c->GetSpectrumModel()->GetNumBands());
     std::size_t num20MhzBands = channelWidth / 20;
     std::size_t numAllocatedSubcarriersPer20MHz = 52;
     NS_ASSERT(puncturedSubchannels.empty() || (puncturedSubchannels.size() == num20MhzBands));
-    double txPowerPerBandW = (txPowerW / numAllocatedSubcarriersPer20MHz) / num20MhzBands;
-    NS_LOG_DEBUG("Power per band " << txPowerPerBandW << "W");
+    const auto txPowerPerBand = (txPower / numAllocatedSubcarriersPer20MHz) / num20MhzBands;
+    NS_LOG_DEBUG("Power per band " << txPowerPerBand << "W");
 
     std::size_t numSubcarriersPer20MHz = (20 * 1e6) / carrierSpacing;
     std::size_t numUnallocatedSubcarriersPer20MHz =
         numSubcarriersPer20MHz - numAllocatedSubcarriersPer20MHz;
-    std::vector<WifiSpectrumBandIndices>
-        subBands; // list of data/pilot-containing subBands (sent at 0dBr)
-    subBands.resize(num20MhzBands *
-                    2); // the center subcarrier is skipped, hence 2 subbands per 20 MHz subchannel
+    std::vector<std::vector<WifiSpectrumBandIndices>> subBandsPerSegment(
+        centerFrequencies.size()); // list of data/pilot-containing subBands (sent at 0dBr)
+    for (std::size_t i = 0; i < centerFrequencies.size(); ++i)
+    {
+        subBandsPerSegment.at(i).resize(
+            num20MhzBands * 2 / centerFrequencies.size()); // the center subcarrier is skipped,
+                                                           // hence 2 subbands per 20 MHz subchannel
+    }
+    std::vector<std::vector<WifiSpectrumBandIndices>> puncturedBandsPerSegment;
     uint32_t start = (nGuardBands / 2) + (numUnallocatedSubcarriersPer20MHz / 2);
     uint32_t stop;
     uint8_t index = 0;
-    for (auto it = subBands.begin(); it != subBands.end();)
+    for (auto& subBands : subBandsPerSegment)
     {
-        if (!puncturedSubchannels.empty() && puncturedSubchannels.at(index++))
+        puncturedBandsPerSegment.emplace_back();
+        for (auto it = subBands.begin(); it != subBands.end();)
         {
-            // if subchannel is punctured, skip it and go the next one
-            NS_LOG_DEBUG("20 MHz subchannel " << +index << " is punctured");
-            it += 2;
-            continue;
-        }
-        stop = start + (numAllocatedSubcarriersPer20MHz / 2) - 1;
-        *it = std::make_pair(start, stop);
-        ++it;
-        start = stop + 2; // skip center subcarrier
-        stop = start + (numAllocatedSubcarriersPer20MHz / 2) - 1;
-        *it = std::make_pair(start, stop);
-        ++it;
-        start = stop + numUnallocatedSubcarriersPer20MHz;
+            stop = start + (numAllocatedSubcarriersPer20MHz / 2) - 1;
+            *it = std::make_pair(start, stop);
+            ++it;
+            uint32_t puncturedStart = start;
+            start = stop + 2; // skip center subcarrier
+            stop = start + (numAllocatedSubcarriersPer20MHz / 2) - 1;
+            *it = std::make_pair(start, stop);
+            ++it;
+            start = stop + numUnallocatedSubcarriersPer20MHz;
+            uint32_t puncturedStop = stop;
+            if (!puncturedSubchannels.empty() && puncturedSubchannels.at(index++))
+            {
+                puncturedBandsPerSegment.back().emplace_back(puncturedStart, puncturedStop);
+            }
+        }
+        start += nUnallocatedBands;
     }
 
     // Prepare spectrum mask specific variables
     auto innerSlopeWidth = static_cast<uint32_t>(
         (2e6 / carrierSpacing) +
         0.5); // size in number of subcarriers of the 0dBr<->20dBr slope (2MHz for HT/VHT)
-    WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands);
+    WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands + nUnallocatedBands);
+    const auto puncturedSlopeWidth =
+        static_cast<uint32_t>((500e3 / carrierSpacing) +
+                              0.5); // size in number of subcarriers of the punctured slope band
 
     // Build transmit spectrum mask
     CreateSpectrumMaskForOfdm(c,
-                              subBands,
+                              subBandsPerSegment,
                               maskBand,
-                              txPowerPerBandW,
+                              txPowerPerBand,
                               nGuardBands,
                               innerSlopeWidth,
-                              minInnerBandDbr,
-                              minOuterBandDbr,
-                              lowestPointDbr);
-    NormalizeSpectrumMask(c, txPowerW);
-    NS_ASSERT_MSG(std::abs(txPowerW - Integral(*c)) < 1e-6, "Power allocation failed");
+                              minInnerBand,
+                              minOuterBand,
+                              lowestPoint,
+                              puncturedBandsPerSegment,
+                              puncturedSlopeWidth);
+    NormalizeSpectrumMask(c, txPower);
+    NS_ASSERT_MSG(std::abs(txPower - Integral(*c)) < 1e-6, "Power allocation failed");
     return c;
 }
 
 Ptr<SpectrumValue>
-WifiSpectrumValueHelper::CreateHtOfdmTxPowerSpectralDensity(uint32_t centerFrequency,
-                                                            uint16_t channelWidth,
-                                                            double txPowerW,
-                                                            uint16_t guardBandwidth,
-                                                            double minInnerBandDbr,
-                                                            double minOuterBandDbr,
-                                                            double lowestPointDbr)
-{
-    NS_LOG_FUNCTION(centerFrequency << channelWidth << txPowerW << guardBandwidth << minInnerBandDbr
-                                    << minOuterBandDbr << lowestPointDbr);
-    uint32_t carrierSpacing = 312500;
+WifiSpectrumValueHelper::CreateHtOfdmTxPowerSpectralDensity(
+    const std::vector<MHz_u>& centerFrequencies,
+    MHz_u channelWidth,
+    Watt_u txPower,
+    MHz_u guardBandwidth,
+    dBr_u minInnerBand,
+    dBr_u minOuterBand,
+    dBr_u lowestPoint)
+{
+    NS_ASSERT_MSG(centerFrequencies.size() == 1 ||
+                      (channelWidth == 160 && centerFrequencies.size() <= 2),
+                  "PSD for non-contiguous channels is only possible when the total width is 160 "
+                  "MHz and cannot be made of more than 2 segments");
+    NS_LOG_FUNCTION(printFrequencies(centerFrequencies)
+                    << channelWidth << txPower << guardBandwidth << minInnerBand << minOuterBand
+                    << lowestPoint);
+    const Hz_u carrierSpacing = 312500;
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
-        GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth));
-    auto nGuardBands = static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
-    auto nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
-    NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() == (nAllocatedBands + nGuardBands + 1),
+        GetSpectrumModel(centerFrequencies, channelWidth, carrierSpacing, guardBandwidth));
+    // assume all frequency segments have the same width, hence split the guard bandwidth
+    // accordingly over the segments
+    guardBandwidth /= centerFrequencies.size();
+    const auto nGuardBands =
+        static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
+    const auto nAllocatedBands =
+        static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+    const auto separationWidth = std::abs(centerFrequencies.back() - centerFrequencies.front());
+    const auto unallocatedWidth = separationWidth > 0 ? (separationWidth - (channelWidth / 2)) : 0;
+    const auto nUnallocatedBands =
+        static_cast<uint32_t>(((unallocatedWidth * 1e6) / carrierSpacing) + 0.5);
+    NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() ==
+                      (nAllocatedBands + nGuardBands + nUnallocatedBands + 1),
                   "Unexpected number of bands " << c->GetSpectrumModel()->GetNumBands());
     std::size_t num20MhzBands = channelWidth / 20;
     std::size_t numAllocatedSubcarriersPer20MHz = 56;
-    double txPowerPerBandW = (txPowerW / numAllocatedSubcarriersPer20MHz) / num20MhzBands;
-    NS_LOG_DEBUG("Power per band " << txPowerPerBandW << "W");
+    const auto txPowerPerBand = (txPower / numAllocatedSubcarriersPer20MHz) / num20MhzBands;
+    NS_LOG_DEBUG("Power per band " << txPowerPerBand << "W");
 
     std::size_t numSubcarriersPer20MHz = (20 * 1e6) / carrierSpacing;
     std::size_t numUnallocatedSubcarriersPer20MHz =
         numSubcarriersPer20MHz - numAllocatedSubcarriersPer20MHz;
-    std::vector<WifiSpectrumBandIndices>
-        subBands; // list of data/pilot-containing subBands (sent at 0dBr)
-    subBands.resize(num20MhzBands *
-                    2); // the center subcarrier is skipped, hence 2 subbands per 20 MHz subchannel
+    std::vector<std::vector<WifiSpectrumBandIndices>> subBandsPerSegment(
+        centerFrequencies.size()); // list of data/pilot-containing subBands (sent at 0dBr)
+    for (std::size_t i = 0; i < centerFrequencies.size(); ++i)
+    {
+        subBandsPerSegment.at(i).resize(
+            num20MhzBands * 2 / centerFrequencies.size()); // the center subcarrier is skipped,
+                                                           // hence 2 subbands per 20 MHz subchannel
+    }
     uint32_t start = (nGuardBands / 2) + (numUnallocatedSubcarriersPer20MHz / 2);
     uint32_t stop;
-    for (auto it = subBands.begin(); it != subBands.end();)
+    for (auto& subBands : subBandsPerSegment)
     {
-        stop = start + (numAllocatedSubcarriersPer20MHz / 2) - 1;
-        *it = std::make_pair(start, stop);
-        ++it;
-        start = stop + 2; // skip center subcarrier
-        stop = start + (numAllocatedSubcarriersPer20MHz / 2) - 1;
-        *it = std::make_pair(start, stop);
-        ++it;
-        start = stop + numUnallocatedSubcarriersPer20MHz;
+        for (auto it = subBands.begin(); it != subBands.end();)
+        {
+            stop = start + (numAllocatedSubcarriersPer20MHz / 2) - 1;
+            *it = std::make_pair(start, stop);
+            ++it;
+            start = stop + 2; // skip center subcarrier
+            stop = start + (numAllocatedSubcarriersPer20MHz / 2) - 1;
+            *it = std::make_pair(start, stop);
+            ++it;
+            start = stop + numUnallocatedSubcarriersPer20MHz;
+        }
+        start += nUnallocatedBands;
     }
 
     // Prepare spectrum mask specific variables
     auto innerSlopeWidth = static_cast<uint32_t>(
         (2e6 / carrierSpacing) +
         0.5); // size in number of subcarriers of the inner band (2MHz for HT/VHT)
-    WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands);
+    WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands + nUnallocatedBands);
 
     // Build transmit spectrum mask
     CreateSpectrumMaskForOfdm(c,
-                              subBands,
+                              subBandsPerSegment,
                               maskBand,
-                              txPowerPerBandW,
+                              txPowerPerBand,
                               nGuardBands,
                               innerSlopeWidth,
-                              minInnerBandDbr,
-                              minOuterBandDbr,
-                              lowestPointDbr);
-    NormalizeSpectrumMask(c, txPowerW);
-    NS_ASSERT_MSG(std::abs(txPowerW - Integral(*c)) < 1e-6, "Power allocation failed");
+                              minInnerBand,
+                              minOuterBand,
+                              lowestPoint);
+    NormalizeSpectrumMask(c, txPower);
+    NS_ASSERT_MSG(std::abs(txPower - Integral(*c)) < 1e-6, "Power allocation failed");
     return c;
 }
 
 Ptr<SpectrumValue>
 WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(
-    uint32_t centerFrequency,
-    uint16_t channelWidth,
-    double txPowerW,
-    uint16_t guardBandwidth,
-    double minInnerBandDbr,
-    double minOuterBandDbr,
-    double lowestPointDbr,
+    MHz_u centerFrequency,
+    MHz_u channelWidth,
+    Watt_u txPower,
+    MHz_u guardBandwidth,
+    dBr_u minInnerBand,
+    dBr_u minOuterBand,
+    dBr_u lowestPoint,
     const std::vector<bool>& puncturedSubchannels)
 {
-    NS_LOG_FUNCTION(centerFrequency << channelWidth << txPowerW << guardBandwidth << minInnerBandDbr
-                                    << minOuterBandDbr << lowestPointDbr);
-    uint32_t carrierSpacing = 78125;
+    return CreateHeOfdmTxPowerSpectralDensity(std::vector<MHz_u>{centerFrequency},
+                                              channelWidth,
+                                              txPower,
+                                              guardBandwidth,
+                                              minInnerBand,
+                                              minOuterBand,
+                                              lowestPoint,
+                                              puncturedSubchannels);
+}
+
+Ptr<SpectrumValue>
+WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(
+    const std::vector<MHz_u>& centerFrequencies,
+    MHz_u channelWidth,
+    Watt_u txPower,
+    MHz_u guardBandwidth,
+    dBr_u minInnerBand,
+    dBr_u minOuterBand,
+    dBr_u lowestPoint,
+    const std::vector<bool>& puncturedSubchannels)
+{
+    NS_ASSERT_MSG(
+        centerFrequencies.size() == 1 || channelWidth == 160,
+        "PSD for non-contiguous channels is only possible when the total width is 160 MHz");
+    NS_LOG_FUNCTION(printFrequencies(centerFrequencies)
+                    << channelWidth << txPower << guardBandwidth << minInnerBand << minOuterBand
+                    << lowestPoint);
+    const Hz_u carrierSpacing = 78125;
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
-        GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth));
-    auto nGuardBands = static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
-    auto nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
-    NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() == (nAllocatedBands + nGuardBands + 1),
+        GetSpectrumModel(centerFrequencies, channelWidth, carrierSpacing, guardBandwidth));
+    // assume all frequency segments have the same width, hence split the guard bandwidth
+    // accordingly over the segments
+    guardBandwidth /= centerFrequencies.size();
+    const auto nGuardBands =
+        static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
+    const auto separationWidth = std::abs(centerFrequencies.back() - centerFrequencies.front());
+    const auto unallocatedWidth = separationWidth > 0 ? (separationWidth - (channelWidth / 2)) : 0;
+    const auto nUnallocatedBands =
+        static_cast<uint32_t>(((unallocatedWidth * 1e6) / carrierSpacing) + 0.5);
+    const auto nAllocatedBands =
+        static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+    NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() ==
+                      (nAllocatedBands + nGuardBands + nUnallocatedBands + 1),
                   "Unexpected number of bands " << c->GetSpectrumModel()->GetNumBands());
-    double txPowerPerBandW = 0.0;
+    Watt_u txPowerPerBand = 0.0;
     uint32_t start1;
     uint32_t stop1;
     uint32_t start2;
@@ -394,14 +516,14 @@
     // Prepare spectrum mask specific variables
     auto innerSlopeWidth = static_cast<uint32_t>(
         (1e6 / carrierSpacing) + 0.5); // size in number of subcarriers of the inner band
-    std::vector<WifiSpectrumBandIndices>
-        subBands; // list of data/pilot-containing subBands (sent at 0dBr)
-    WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands);
-    switch (channelWidth)
+    std::vector<std::vector<WifiSpectrumBandIndices>> subBandsPerSegment(
+        centerFrequencies.size()); // list of data/pilot-containing subBands (sent at 0dBr)
+    WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands + nUnallocatedBands);
+    switch (static_cast<uint16_t>(channelWidth))
     {
     case 20:
         // 242 subcarriers (234 data + 8 pilot)
-        txPowerPerBandW = txPowerW / 242;
+        txPowerPerBand = txPower / 242;
         innerSlopeWidth =
             static_cast<uint32_t>((5e5 / carrierSpacing) + 0.5); // [-10.25;-9.75] & [9.75;10.25]
         // skip the guard band and 6 subbands, then place power in 121 subbands, then
@@ -411,12 +533,12 @@
         stop1 = start1 + 121 - 1;
         start2 = stop1 + 4;
         stop2 = start2 + 121 - 1;
-        subBands.emplace_back(start1, stop1);
-        subBands.emplace_back(start2, stop2);
+        subBandsPerSegment.at(0).emplace_back(start1, stop1);
+        subBandsPerSegment.at(0).emplace_back(start2, stop2);
         break;
     case 40:
         // 484 subcarriers (468 data + 16 pilot)
-        txPowerPerBandW = txPowerW / 484;
+        txPowerPerBand = txPower / 484;
         // skip the guard band and 12 subbands, then place power in 242 subbands, then
         // skip 5 DC, then place power in 242 subbands, then skip
         // the final 11 subbands and the guard band.
@@ -424,12 +546,12 @@
         stop1 = start1 + 242 - 1;
         start2 = stop1 + 6;
         stop2 = start2 + 242 - 1;
-        subBands.emplace_back(start1, stop1);
-        subBands.emplace_back(start2, stop2);
+        subBandsPerSegment.at(0).emplace_back(start1, stop1);
+        subBandsPerSegment.at(0).emplace_back(start2, stop2);
         break;
     case 80:
         // 996 subcarriers (980 data + 16 pilot)
-        txPowerPerBandW = txPowerW / 996;
+        txPowerPerBand = txPower / 996;
         // skip the guard band and 12 subbands, then place power in 498 subbands, then
         // skip 5 DC, then place power in 498 subbands, then skip
         // the final 11 subbands and the guard band.
@@ -437,25 +559,29 @@
         stop1 = start1 + 498 - 1;
         start2 = stop1 + 6;
         stop2 = start2 + 498 - 1;
-        subBands.emplace_back(start1, stop1);
-        subBands.emplace_back(start2, stop2);
+        subBandsPerSegment.at(0).emplace_back(start1, stop1);
+        subBandsPerSegment.at(0).emplace_back(start2, stop2);
         break;
-    case 160:
+    case 160: {
+        NS_ASSERT_MSG(centerFrequencies.size() <= 2,
+                      "It is not possible to create a PSD made of more than 2 segments for a width "
+                      "of 160 MHz");
         // 2 x 996 subcarriers (2 x 80 MHZ bands)
-        txPowerPerBandW = txPowerW / (2 * 996);
+        txPowerPerBand = txPower / (2 * 996);
         start1 = (nGuardBands / 2) + 12;
         stop1 = start1 + 498 - 1;
         start2 = stop1 + 6;
         stop2 = start2 + 498 - 1;
-        start3 = stop2 + (2 * 12);
+        start3 = stop2 + (2 * 12) + nUnallocatedBands;
         stop3 = start3 + 498 - 1;
         start4 = stop3 + 6;
         stop4 = start4 + 498 - 1;
-        subBands.emplace_back(start1, stop1);
-        subBands.emplace_back(start2, stop2);
-        subBands.emplace_back(start3, stop3);
-        subBands.emplace_back(start4, stop4);
+        subBandsPerSegment.at(0).emplace_back(start1, stop1);
+        subBandsPerSegment.at(0).emplace_back(start2, stop2);
+        subBandsPerSegment.at(subBandsPerSegment.size() - 1).emplace_back(start3, stop3);
+        subBandsPerSegment.at(subBandsPerSegment.size() - 1).emplace_back(start4, stop4);
         break;
+    }
     default:
         NS_FATAL_ERROR("ChannelWidth " << channelWidth << " unsupported");
         break;
